
#include <QApplication>
#include <QWidget>
#include <QtDBus>
#include <QDBusConnection>
#include <QAction>
#include <QProgressBar>
#include <QBasicTimer>
#include <QEvent>
#include <QtGui>
#include <QDBusAbstractAdaptor>
#include <QObject>

class Systray : public QWidget
{
    public:
    Systray(QWidget *parent = 0);
    virtual ~Systray() {};
};

class Center : public QWidget
{
    public:
    Center(QWidget *parent = 0);
    virtual ~Center() {
        delete pbar;
        delete timer;
    };
    void startTimer(int a);
    void timerEvent(QTimerEvent *e );

    QProgressBar *pbar;
    QBasicTimer *timer;
    protected:
    void recenter(void);
//     void timerEvent(void);
};


class TestObject : public QDBusAbstractAdaptor
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.OSD.Volume")
 
    private:
        QApplication *app;
    public:
        TestObject(QApplication *application, Center* mw);

        virtual ~TestObject() {
            delete dbus;
            delete mymixer;
        };

        Center * thewindow;
        QApplication * myapp;

 
        QString masterIdx;
        int volume;
        QDBusConnection *dbus;
//         QDBusConnection *kmixdbus;
        void mycheck();
        QDBusInterface * mymixer;
//         QDBusMessage getmast;
//         QDBusMessage incvol;
//         QDBusMessage decvol;
//         QDBusMessage mastervol;
        QDBusMessage reply;
 
    public slots:
    Q_SCRIPTABLE void reshow(short volu);
    Q_SCRIPTABLE void showinc(void);
    Q_SCRIPTABLE void showdec(void);
    Q_SCRIPTABLE void showme(void);
 
};

